# Build against OpenSSL 3 on EL8
%if 0%{?rhel} == 8
%global openssl_pkgversion 3
%endif

Summary: nginScript module for nginx
Name: nginx-mod-njs
Version: 0.8.1
Release: 1%{?dist}
Vendor: Artera
URL: https://nginx.org/en/docs/njs_about.html

%define _modname            njs
%define _nginxver           1.24.0
%define nginx_config_dir    %{_sysconfdir}/nginx
%define nginx_build_dir     %{_builddir}/nginx-%{_nginxver}

Source0: https://nginx.org/download/nginx-%{_nginxver}.tar.gz
Source1: https://hg.nginx.org/njs/archive/%{version}.tar.gz#/%{_modname}-%{version}.tar.gz

Requires: nginx = 1:%{_nginxver}
Requires: openssl%{?openssl_pkgversion}-libs
BuildRequires: nginx
BuildRequires: libtool
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: openssl%{?openssl_pkgversion}-devel
BuildRequires: pcre2-devel
BuildRequires: zlib-devel
BuildRequires: perl-devel
BuildRequires: gd-devel
BuildRequires: libxslt-devel
BuildRequires: perl-devel
BuildRequires: perl(ExtUtils::Embed)
BuildRequires: gperftools-devel

License: BSD

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
nginScript module for nginx.

%prep
%setup -q -n nginx-%{_nginxver}
%setup -T -D -b 1 -n %{_modname}-%{version}

cd %{_builddir}/nginx-%{_nginxver}
%if 0%{?openssl_pkgversion}
sed \
  -e 's|\(ngx_feature_path=\)$|\1%{_includedir}/openssl%{openssl_pkgversion}|' \
  -e 's|\(ngx_feature_libs="\)|\1-L%{_libdir}/openssl%{openssl_pkgversion} |' \
  -i auto/lib/openssl/conf
%endif

%build
cd %{_builddir}/njs-%{version}
CFLAGS="$CFLAGS -Wno-dangling-pointer -Wno-maybe-uninitialized" ./configure
make njs

# next configure cleans the build directory
mv build/njs %{_builddir}/

cd %{_builddir}/nginx-%{_nginxver}
./configure \
    --with-compat \
    --with-stream=dynamic \
    --with-http_ssl_module \
    --with-openssl-opt=enable-ktls \
    --with-http_v2_module \
    --add-dynamic-module=../njs-%{version}/nginx
make modules

%install
%{__rm} -rf %{buildroot}

%{__install} -Dm755 %{_builddir}/njs %{buildroot}%{_bindir}/njs

%{__install} -Dm755 %{nginx_build_dir}/objs/ngx_http_js_module.so \
    $RPM_BUILD_ROOT%{_libdir}/nginx/modules/ngx_http_js_module.so
%{__install} -Dm755 %{nginx_build_dir}/objs/ngx_stream_js_module.so \
    $RPM_BUILD_ROOT%{_libdir}/nginx/modules/ngx_stream_js_module.so

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%{_bindir}/njs
%{_libdir}/nginx/modules/*.so
